#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "odicon.h"


int MorL(char c) {
    c = toupper(c);
    return (c == 'M') || (c == 'L') || (c == 'S') || (c == 'Q') || (c == 'D');
}


int main(int argc, char *argv[]) {
    int dim, seed = 12345;

    if (argc <= 1 || strlen(argv[1]) != 1 || !MorL(argv[1][0])) {
        fprintf(stderr, "Give me 'M', 'L', or 'S'.\n");
        return EXIT_FAILURE;
    }

    if (argc <= 2) {
        fprintf(stderr, "Give me dimension.\n");
        return EXIT_SUCCESS;
    }

    dim = atoi(argv[2]);
    if (argc > 3) seed = atoi(argv[3]);

    mt_initialize(seed);
    if (argv[1][0] != 'D') printf("%s: dim = %d, seed = %d\n", argv[0], dim, seed);
    cpu_time();

    switch (argv[1][0]) {
    case 'M': mconv(dim);  break;
    case 'L': lconv2(dim); break;
    case 'S': submodular(dim); break;
    case 'Q': qlconv(dim); break;
    case 'D':
        cpu_time_limit = 5; /* 5sec */
        switch (argv[3][0]) {
        case 'L': demo_Lseparable(dim); break;
        case 'M': demo_Mseparable(dim); break;
        case 'Z': demo_procurement(dim); break;
        }
        break;

        /* followings are dummy */
    case 1: mconv(dim);  break;
    case 2: mconv2();    break;
    case 3: lconv(dim);  break;
    case 4: lconv2(dim); break;
    case 5: lconv_long(dim); break;
    default: printf("%s: '%c' is an invalid argument.\n", argv[0], argv[1][0]);
    }
    return EXIT_SUCCESS;
}
